﻿Type=Class
Version=1.05
B4J=true
@EndOfDesignText@
'Class module
Sub Class_Globals
	Private fx As JFX
	Private tv As TableView
	Public maxrows As Int
	Public rows As Double
	Public cols As Int
	Private cellheight As Int = 25
	Private colFormatStr As String
End Sub

'Initializes the object. You can add parameters to this method if needed.
Public Sub Initialize(tView As TableView,formatStr As String)
	tv = tView
	'Log("tView")
	cols = tv.ColumnsCount
	'Log("cols " & cols)
	colFormatStr = formatStr
	'Log("format " & colFormatStr)
End Sub

Public Sub setMaxRows(tvHeight As Int)
	maxrows = (tvHeight/cellheight)
	maxrows = maxrows + 0.5
	maxrows = Round(maxrows)
End Sub

Public Sub addRow(data As String) As String
	Dim lbl(cols) As Object
	Dim colData(cols) As String
	Dim align(cols) As String
	Dim i As Int

	'split the data string
	colData = Regex.Split("#",data)

	'split the format string
	align = Regex.Split("#",colFormatStr)

	'check for "" alignments and set to default
	For i=0 To cols-1
		If align(i) = "" Then
			align(i) = "CENTER_LEFT"
		End If
	Next 
	
	'ensure that there are as many #'s in the string as columns
	If colData.Length <> cols Then
		Return "Columns Not Matched"
	End If

	Dim panes(cols) As Object
	For i=0 To cols-1
		Dim lab As Label
		lab.Initialize("")
		lab.Text = colData(i)
		lbl(i) = lab
		panes(i) = WrapLabel(lbl(i),align(i))
	Next

	'do this until I am smarter
	Select cols-1
		Case 0
			tv.Items.Add(Array As Object(panes(0)))		
		Case 1
			tv.Items.Add(Array As Object(panes(0),panes(1)))		
		Case 2
			tv.Items.Add(Array As Object(panes(0),panes(1),panes(2)))
		Case 3
			tv.Items.Add(Array As Object(panes(0),panes(1),panes(2),panes(3)))		
		Case 4
			tv.Items.Add(Array As Object(panes(0),panes(1),panes(2),panes(3),panes(4)))		
		Case 5
			tv.Items.Add(Array As Object(panes(0),panes(1),panes(2),panes(3),panes(4),panes(5)))		
		Case 6
			tv.Items.Add(Array As Object(panes(0),panes(1),panes(2),panes(3),panes(4),panes(5),panes(6)))		
		Case 7
			tv.Items.Add(Array As Object(panes(0),panes(1),panes(2),panes(3),panes(4),panes(5),panes(6),panes(7)))		
		Case 8
			tv.Items.Add(Array As Object(panes(0),panes(1),panes(2),panes(3),panes(4),panes(5),panes(6),panes(7),panes(8)))		
		Case 9
			tv.Items.Add(Array As Object(panes(0),panes(1),panes(2),panes(3),panes(4),panes(5),panes(6),panes(7),panes(8),panes(9)))		
	End Select
	rows = rows + 1
	
	Return ""
End Sub

Private Sub WrapLabel(lbl As Label, Alignment As String) As Pane
   Dim pn1 As AnchorPane
   pn1.Initialize("")
   pn1.AddNode(lbl, 0, 0, -1, -1)
   pn1.FillHorizontally(lbl, 0, 0)
   Dim jo1 = lbl As JavaObject
   jo1.RunMethod("setAlignment", Array As Object(Alignment))
   Return pn1
End Sub

Public Sub clearTable
	tv.Items.Clear
End Sub