﻿Type=StaticCode
Version=1.05
B4J=true
@EndOfDesignText@

Sub Process_Globals
	Private fx As JFX
End Sub
Sub GetRandomKey() As String
    'Generate a random 16 character key For use in RecordId's
  Dim i,j As Int
  Dim rkey As String
  Dim truefalse As Boolean
  truefalse = True
  i = 0
  j = 0
  rkey = ""
  For i =1 To 16
    Do While truefalse
      j = Rnd(47,123)
      If (j > 47 AND j < 58) OR (j > 64 AND j < 91) OR (j > 96 AND j < 123) Then
        rkey =rkey & Chr(j)
        Exit
      End If 
    Loop
  Next
  Return rkey
End Sub

Sub checkNum(num As String,wp As Int,dp As Int,zf As Boolean) As String
	'num = passed text with numbers
	'wp  = whole places
	'dp  = decimal places
	'zf  = zerofill
	Dim whole As String
	Dim fract As String
	Dim isDecimal As Boolean
	Dim answer As String
	Dim i ,start,fin As Int
	num = num.Trim
	If num = "" Then
		num = "0"
	End If
	'is there a decimal point
	If num.IndexOf(".") = -1 Then
		'no, so is it a number
		If IsNumber(num) = False Then
			'Msgbox("Not a number","Validating")
			Return ""
		End If
		whole = num
		fract = ""
	Else
		isDecimal = True
		i = num.IndexOf(".")
		whole = num.SubString2(0,i)
		fract = num.SubString2(i+1,num.Length)
		If IsNumber(whole) = False OR IsNumber(fract) = False OR fract.Contains(".") = True Then
			'Msgbox("Not a number","Validating")
			Return ""		
		End If
	End If


	'sort out fraction to be equal to dp's
	If fract.Length > dp Then
		fract = fract.SubString2(0,dp)
	Else If fract.Length < dp Then
		fract = fract & "0000".SubString2(0,(dp-fract.Length))
	End If
	'sort out length of whole
	If whole.Length > wp Then
		fin = whole.Length
		start = whole.Length - wp
		whole = whole.SubString2(start,fin)
	Else If whole.Length < wp Then
		whole = "      ".SubString2(0,wp-whole.Length) & whole
	End If
	If zf = True Then
		whole = whole.Replace(" ","0")
	End If
	answer = whole & "." & fract
	Return answer
End Sub

Sub getSqlFromNormalDate(dt As String) As String
	Dim sqlDt As String	
	Dim dTiks As Long
	If dt.Trim = "" Then
		Return ""
	End If
	DateTime.DateFormat = "dd/MM/yyyy"
	'get tiks of date
	dTiks = DateTime.DateParse(dt)
	'change to sql format
	DateTime.DateFormat = "yyyy/MM/dd"
	sqlDt = DateTime.Date(dTiks)
	Return sqlDt
End Sub

Sub getNormalFromSqlDate(sqlDt As String) As String
	Dim dt As String
	Dim dTiks As Long
	If sqlDt.Trim = "" Then
		Return ""
	End If
	DateTime.DateFormat = "yyyy/MM/dd"
	dTiks = DateTime.DateParse(sqlDt)
	'change to normal format
	DateTime.DateFormat = "dd/MM/yyyy"
	dt = DateTime.Date(dTiks)
	Return dt
End Sub

Sub getNormalToday As String
	Dim now As Long
	Dim normalNow As String
	
	now = DateTime.now
	DateTime.DateFormat = "dd/MM/yyyy"
	normalNow = DateTime.Date(now)
	Return normalNow
End Sub

Sub getSqlToday As String
	Dim now As Long
	Dim sqlNow As String
	
	now = DateTime.now
	DateTime.DateFormat = "yyyy/MM/dd"
	sqlNow = DateTime.Date(now)
	Return sqlNow
End Sub

Sub validateDate(dt As String) As String
	Dim found As Boolean
	Dim ldate As Long
	Dim dType As Int
	
	found = False
	'check format
	If Regex.IsMatch("\d\d/\d\d/\d\d\d\d",dt) = True Then
		found = True
		dType = 1
	Else If Regex.IsMatch("\d\d\d\d\d\d\d\d",dt) = True Then
		found = True
		dType = 2
	End If
	
	If found = False Then
		Return ""
	End If
	
	If dType = 1 Then
		DateTime.DateFormat = "dd/MM/yyyy"
	Else If dType = 2 Then
		DateTime.DateFormat = "ddMMyyyy"
	End If
	
	'check validity
	Try
		ldate = DateTime.DateParse(dt)	
	Catch
		found = False
	End Try
	
	DateTime.DateFormat = "ddMMyyyy"
	If found = False Then Return ""
	If dType = 1 Then Return dt
	If dType = 2 Then
		ldate = DateTime.DateParse(dt)
		DateTime.DateFormat = "dd/MM/yyyy"
		Return DateTime.Date(ldate)
	End If

End Sub
Sub validateTime(tm As String,Is24Hrs As Boolean) As String
	Dim found As Boolean
	Dim tiks As Long

	Select tm.Length
	Case 1
		If tm.Contains(":") = True Then
			tm = ""
		Else
			tm = "0"&tm&":00"
		End If
	Case 2
		If tm.contains(":") = True Then
			tm = tm & ":00"
		Else
			If tm < 24 Then
				tm = tm&":00"
			Else
				tm = ""
			End If
		End If
	Case 3
		If tm.Contains(":") = False Then
			If tm.SubString2(0,2) < 24 Then
				tm = tm.SubString2(0,1) & ":" & tm.SubString(1)
			End If
		End If
	Case 4
		If tm.Contains(":") = False Then
			tm = tm.SubString2(0,2) & ":" & tm.SubString(2)
		End If
	End Select
	
	If tm.Length < 5 Then
		If tm.IndexOf(":") = 1 Then
			tm = "0" & tm
		End If
		If tm.SubString(tm.IndexOf(":") + 1).Length = 1 Then
			tm = tm.SubString2(0,3) & "0" & tm.SubString(3)
		End If
	End If

	If Is24Hrs = True Then
		found = Regex.IsMatch("\d\d:\d\d",tm)
	Else
		found = Regex.IsMatch("\d\d:\d\d[aApP][mM]",tm)
	End If

	If found = False Then Return ""
	If Is24Hrs = True Then
		DateTime.TimeFormat = "HH:mm"
	Else
		DateTime.TimeFormat = "hh:mma"
	End If
	
	Try
		tiks = DateTime.TimeParse(tm)
	Catch
		found = False
	End Try

	If found = False Then 
		Return ""
	Else
		Return tm
	End If
End Sub